
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Purchase_order_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_lines = await db.purchase_order_lines.create(
            {
                id: data.id || undefined,
        
        ordered_quantity: data.ordered_quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        need_by_at: data.need_by_at
        ||
        null
            ,
            
        line_notes: data.line_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await purchase_order_lines.setPurchase_order( data.purchase_order || null, {
            transaction,
        });
        
        await purchase_order_lines.setMaterial( data.material || null, {
            transaction,
        });
        
        await purchase_order_lines.setUom( data.uom || null, {
            transaction,
        });
        

        

        

        return purchase_order_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const purchase_order_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                ordered_quantity: item.ordered_quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                need_by_at: item.need_by_at
            ||
            null
            ,
            
                line_notes: item.line_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const purchase_order_lines = await db.purchase_order_lines.bulkCreate(purchase_order_linesData, { transaction });

        // For each item created, replace relation files
        

        return purchase_order_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const purchase_order_lines = await db.purchase_order_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.ordered_quantity !== undefined) updatePayload.ordered_quantity = data.ordered_quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.need_by_at !== undefined) updatePayload.need_by_at = data.need_by_at;
        
        
        if (data.line_notes !== undefined) updatePayload.line_notes = data.line_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await purchase_order_lines.update(updatePayload, {transaction});

        
        
        if (data.purchase_order !== undefined) {
            await purchase_order_lines.setPurchase_order(
              
              data.purchase_order,
              
              { transaction }
            );
        }
        
        if (data.material !== undefined) {
            await purchase_order_lines.setMaterial(
              
              data.material,
              
              { transaction }
            );
        }
        
        if (data.uom !== undefined) {
            await purchase_order_lines.setUom(
              
              data.uom,
              
              { transaction }
            );
        }
        

        
        

        

        return purchase_order_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_lines = await db.purchase_order_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of purchase_order_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of purchase_order_lines) {
                await record.destroy({transaction});
            }
        });


        return purchase_order_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_lines = await db.purchase_order_lines.findByPk(id, options);

        await purchase_order_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await purchase_order_lines.destroy({
            transaction
        });

        return purchase_order_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_lines = await db.purchase_order_lines.findOne(
            { where },
            { transaction },
        );

        if (!purchase_order_lines) {
            return purchase_order_lines;
        }

        const output = purchase_order_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.purchase_order = await purchase_order_lines.getPurchase_order({
            transaction
        });
        
        
        output.material = await purchase_order_lines.getMaterial({
            transaction
        });
        
        
        output.uom = await purchase_order_lines.getUom({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.purchase_orders,
        as: 'purchase_order',
        
        where: filter.purchase_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.purchase_order.split('|').map(term => Utils.uuid(term)) } },
            {
              po_number: {
                [Op.or]: filter.purchase_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.materials,
        as: 'material',
        
        where: filter.material ? {
          [Op.or]: [
            { id: { [Op.in]: filter.material.split('|').map(term => Utils.uuid(term)) } },
            {
              material_name: {
                [Op.or]: filter.material.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.units_of_measure,
        as: 'uom',
        
        where: filter.uom ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uom.split('|').map(term => Utils.uuid(term)) } },
            {
              uom_code: {
                [Op.or]: filter.uom.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.line_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_order_lines',
                        'line_notes',
                        filter.line_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.ordered_quantityRange) {
                const [start, end] = filter.ordered_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ordered_quantity: {
                    ...where.ordered_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ordered_quantity: {
                    ...where.ordered_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.need_by_atRange) {
                const [start, end] = filter.need_by_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    need_by_at: {
                    ...where.need_by_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    need_by_at: {
                    ...where.need_by_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.purchase_order_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'purchase_order_lines',
                        'line_notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.purchase_order_lines.findAll({
            attributes: [ 'id', 'line_notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['line_notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.line_notes,
        }));
    }

    
};

